﻿--[[

function TT:GameTooltip_OnTooltipSetItem(tt)



1 --if link ~= nil then2 -- left = "|cFFCA3C3C"..ID.."|r "..link:match(":(%w+)")3 --end


]]--







-- Priority List
-- by Fluffies- EU-Well of Eternity

local addon	= PriorityList
local addonName, addonTable = ...
local L = addonTable.L

LibStub("AceSerializer-3.0"):Embed(addon)
LibStub("AceComm-3.0"):Embed(addon)

-- list version: this will be checked whenever the list has to be imported/exported
-- increment this number if the list structure changes
-- and apply a list upgrade fix in Init()
 addon.version = 1003
-- history
-- 1001/1002 - Items_List structure changes
-- 1003 - converted Items_List to PLWish_List (character focused structure)
--

-- string colors
local LIGHT_BLUE  = "|cff00ccff"
local LIGHT_RED   = "|cffff6060"
local GREEN       = "|cff71C671"
local LIGHT_GREEN = "|cff71FF71"
local YELLOW      = "|cffffff00"
local GREY        = "|cff888888"
local GOLD        = "|cffffcc00"
local RED         = "|cffff0000"
local WHITE       = "|cffffffff"
local function AddColor(str,color)
 return color..str.."|r"
end

-- constants
local boss_drops_table = addon.boss_drops_table
local PRIO_LOOTED = 99
addon.wl_folding = {}

-- variables --
addon.lootlist = {}
addon.waiting_ids = {}
addon.import_var = {
              sender = "",
              ready  = false,
              Wish_List     = {},
              Items_List    = {},
              Deleting_List = {},
              requests      = {},
              folding       = {},
              tosend        = nil,
              timer         = nil,
              counter = 0,
             }
-----------------

local function OptionsOpened()
 if addon.opt.frm_items then
  return addon.opt.frm_items:IsVisible()
 else
  return false
 end
end
                              -- overrides options' checkbox, same as if the checkbox is checked
function addon:ConfirmCheck(f,override)
 if pl_options["confirm_edit"] or override then -- confirm dialog
  local dialog = StaticPopup_Show("pl_confirmdialog")
  if dialog then
   if override then dialog.text:SetText(L["resetwish_txt"]) else dialog.text:SetText(L["confirmcng"]) end  
   dialog.data2 = f
  end
 else
  f()
 end
end

function addon:IsSimpleMode()
 if pl_options["simple_mode"] then 
  return true 
 else
  return false 
 end
end

function addon:Extr_ItemProp(itemID)
 local itemID = abs(itemID)

 local CHAR_ID = 999999
 local itemname, itemLink,_,_,_,_,_,_,_, itemTexture = GetItemInfo(itemID)
 if itemID == 0 then
  itemname = L["newitem"]
  itemTexture = "Interface\\ICONS\\INV_Misc_QuestionMark.blp"
-- elseif itemID == CHAR_ID then
--  itemname    = "char"
--  itemTexture = "Interface\\ICONS\\Achievement_Character_Human_Male.blp"
 else
  if itemLink == nil then
   if addon.waiting_ids[itemID] == nil then
    addon.waiting_ids[itemID] = {["timer"] = addon:ScheduleTimer("Waiting_ID_Timer", 10, itemID)}
    itemTexture = "Interface\\ICONS\\Ability_Mage_TimeWarp.blp"
    itemname = L["RecItemInfo"]
   elseif addon.waiting_ids[itemID]["timer"] then
    itemTexture = "Interface\\ICONS\\Ability_Mage_TimeWarp.blp"
    itemname = L["RecItemInfo"]
   end
  end
 end
 if not itemname then -- waiting timed out
  itemname = L["IDnotfound"]
  itemTexture = "Interface\\ICONS\\INV_Misc_QuestionMark.blp"
 end
 return itemname, itemLink, itemTexture
end --Extr_ItemProp[erties]

function addon:MatchBossDrop(id)
 local tmp_boss = ""
 local tmp_icon = ""
 local tmp_raid = ""

 table.foreach(boss_drops_table,
 function(k,v)                                      -- boss name / difficulty table
 for i,j in pairs(v) do
  for diff_index,diff_id_table in pairs(j) do       -- difficulty / loot table
   if type(diff_id_table) == "table" then
    for item_index,item_id in pairs(diff_id_table) do -- index / single item
    if item_id == id then
     tmp_boss = i..AddColor(" ("..diff_index..")",LIGHT_RED)
     tmp_raid = k
     if j["icon"] then
      tmp_icon = j["icon"]
     else
      tmp_icon = addon.BOSS_ICON_UNKNOWN
     end
     break
    end
   end
  end
  end
 end
 end)

 if tmp_boss == "" then
  tmp_boss = L["Dropnotfound"]
  tmp_icon = addon.BOSS_ICON_UNKNOWN
 end
 return tmp_boss,tmp_icon,tmp_raid -- returning also raidname for raid selection v2.0.6
end

-- raid selection v2.0.6
 function addon:itemisinraid(id,raid)
  local _,_,raidname = addon:MatchBossDrop(id)
  if raid == raidname or raid == L["all_raids"] then
   return true else return false
  end
 end
 
 function addon:getitemsraid(id)
  local _,_,raidname = addon:MatchBossDrop(abs(id))
  if raidname == "" then raidname = "general" end
  if not addon.lootlist[raidname] then addon.lootlist[raidname] = {} end
  return raidname
 end
--

function addon:TableMatch(tab,arg,exact)
local result = false
if not tab then 
 return false
else
 table.foreach(tab,
  function(k,v)
   if exact then
    if type(arg) == "string" then
     if v:lower() == arg:lower() then result = true end
    else
     if abs(v) == abs(arg) then result = true end
    end
   elseif type(v) == "string" and type(arg) == "string" then
    if v:lower():find(arg:lower()) then result = true end
   end
  end)
 return result
end
end

function addon:MergeNames(tab)
if tab ~= nil then
 local names = ""
 local col_names = ""
 local spacer = ""
 local col_spacer = ""
 local prev_prio = -1
 table.foreach(tab,
  function(k,v)
   if v.prio == prev_prio then
    spacer = "/"
    col_spacer = AddColor("/",LIGHT_GREEN)..GREY
   else
    if v.prio == PRIO_LOOTED then
     spacer = " ("
     col_spacer = AddColor(" (",LIGHT_BLUE)..GREY
    else
     spacer = " "
     col_spacer = " "
    end
   end
   prev_prio = v.prio
   names = names..spacer..v.name
   col_names = col_names..col_spacer..v.name
  end)
  if prev_prio == PRIO_LOOTED then
   names = names.." "..L["Looted"]..")"
   col_names = col_names..AddColor(" "..L["Looted"]..")",LIGHT_BLUE)
  end
 return names,col_names
else
 return "",""
end
end

function addon:GenerateItemsList(list)
--if list == "main" then
 wipe(Items_List)
 table.foreach(PLWish_List,
 function(k,v) --name / IDs table
  for i,itemID in pairs(v) do -- index / single IDs
   if not Items_List[abs(itemID)] then
    Items_List[abs(itemID)] = {}
   end
   if itemID >= 0 then -- < 0 means already looted
    table.insert(Items_List[itemID], {name = k, prio = i})
   else
    table.insert(Items_List[abs(itemID)], {name = k, prio = PRIO_LOOTED})
   end
  end
 end)
 table.foreach(Items_List,function(k,v) table.sort(v, function(a,b) return a.prio < b.prio end) end)

--elseif list == "import" then
  wipe(addon.import_var.Items_List)
  wipe(addon.import_var.Deleting_List)
  table.foreach(addon.import_var.Wish_List,
  function(k,v) --player name / IDs table
   for charname,itemstable in pairs(v) do
    for i,itemID in pairs(itemstable) do -- index / single IDs
     if not addon.import_var.Items_List[itemID] then
      addon.import_var.Items_List[itemID] = {}
     end
     if not addon.import_var.Items_List[itemID][k] then
      addon.import_var.Items_List[itemID][k] = {}
     end
     table.insert(addon.import_var.Items_List[itemID][k], {name = charname, prio = i})
    end

 -- pending deletion items
  if PLWish_List[charname] then
   table.foreach(PLWish_List[charname],
    function(index,itemID)
     if addon.import_var.Wish_List[k] then
      if not addon:TableMatch(addon.import_var.Wish_List[k][charname],itemID,true) then
       if not addon.import_var.Deleting_List[k] then
        addon.import_var.Deleting_List[k] = {}
       end
       if not addon.import_var.Deleting_List[k][charname] then
        addon.import_var.Deleting_List[k][charname] = {}
       end
       table.insert(addon.import_var.Deleting_List[k][charname], itemID)
      end
     end
    end)
   end
   end --charname/itemstable
  end)
  table.foreach(addon.import_var.Items_List,function(k,v) table.sort(v, function(a,b) return a.prio < b.prio end) end)
--end
  addon:GenerateLootList()
end

function addon:GenerateLootList()
 local tmpraid = ""
 local i_prio = {}
 wipe(addon.lootlist)
 table.foreach(PLWish_List,
 function(k,v) --name / IDs table
  wipe(i_prio)
  for i,itemID in pairs(v) do -- index / single IDs
    tmpraid = addon:getitemsraid(itemID)
    if not i_prio[tmpraid] then i_prio[tmpraid] = 0 else
    i_prio[tmpraid] = i_prio[tmpraid]+1 end
    if not addon.lootlist[tmpraid] then addon.lootlist[tmpraid] = {} end
    if not addon.lootlist[tmpraid][abs(itemID)] then addon.lootlist[tmpraid][abs(itemID)] = {} end
    if itemID >= 0 then -- < 0 means already looted
     table.insert(addon.lootlist[tmpraid][itemID], {name = k, prio = i_prio[tmpraid]})
    else
     table.insert(addon.lootlist[tmpraid][abs(itemID)], {name = k, prio = PRIO_LOOTED})
    end
   end
  end)

  table.foreach(addon.lootlist,function(k,v) 
  table.foreach(v,function(i,j) table.sort(j, function(a,b) return a.prio < b.prio end) end)
 end)
end

function addon:OnInitialize()
 self:RegisterChatCommand("prioritylist", "HandleSlashCommands")
 self:RegisterChatCommand("pl", "HandleSlashCommands")
end

function addon:Init()
 if Items_List == nil then
  Items_List = {
  }
 end

 if PLWish_List == nil then
  PLWish_List = {
   -- list structure ----------------------
   -- ["CharName"] = {ID,ID,ID,ID,ID,ID} --
   ----------------------------------------
  }
 end

 if not pl_options then pl_options = {} end
 if pl_options["ttlinkbtn"] == nil then
  pl_options["ttlinkbtn"] = true end -- "add item" button in any tooltip item link
 if pl_options["confirm_edit"] == nil then
  pl_options["confirm_edit"] = false end --  confirm item list changes
 if pl_options["simple_mode"] == nil then
  pl_options["simple_mode"] = true end -- simple mode for raiders
 if pl_options["treatdiff"] == nil then
  pl_options["treatdiff"] = true end -- show different difficulty items in tooltip
 if pl_options["background"] == nil or pl_options == "" then
  pl_options["background"] = "Interface\\GLUES\\LOADINGSCREENS\\LOADSCREENWANDERINGISLE.BLP" end -- background image
 if pl_options["current_raid"] == nil or pl_options == "" then
  pl_options["current_raid"] = L["all_raids"] end -- current raid selection

 if pl_options["version"] == nil or pl_options["version"] < addon.version then
-- upgrading from older versions
  print("Upgrading PriorityList from an older version")
  pl_options["impsndtype"] = nil -- no more need of this

  if not pl_options["version"] then pl_options["version"] = 1 end
 -- old items_list --> new items_list
 if pl_options["version"] < 1000 then
  table.foreach(Items_List,
   function(k,v)
    if v[1] ~= nil then
     Items_List[v[1]] = {["needers"] = v[2]}
     Items_List[k] = nil
    end
   end)
  pl_options["version"] = 1000
 end
 -- items_list --> PLwish_list conversion
 if pl_options["version"] < 1003 then
   local didsomething = true
   local word = ""
   local i,j = 0,0
   wipe(PLWish_List)
   while didsomething do
    didsomething = false
    table.foreach(Items_List,
     function(k,v) --items_list cycle for every level of priority
      if v["needers"] then
       if v["needers"]:find("%a+") then
        i,j = v["needers"]:find("%a+")
        word = string.sub(v["needers"],i,j)
        v["needers"] = string.sub(v["needers"],j+1)
       else
        word = nil
       end
       if word and k ~= 0 then
        if not PLWish_List[word] then
         PLWish_List[word] = {}
        end
        table.insert(PLWish_List[word], k)
        didsomething = true
       end
      end
     end)
    end
   end
  pl_options["version"] = 1003
 end
--
 addon:GenerateItemsList("main")
end

function addon:OnEnable()
 PriorityList:Init()
end

function addon:HandleSlashCommands(input)
 if not InCombatLockdown() then
  if not Items_List then addon:GenerateItemsList("main") end
  PriorityList:Init_OptionsFrame("main")
 else
  DEFAULT_CHAT_FRAME:AddMessage(AddColor("<<"..L["<addon name>"]..">>",LIGHT_BLUE).." - "..L["cantopenincombat"])
 end
end

local tmp = nil
function addon:Waiting_ID_Timer(arg)
 if arg == "##initrefresh##" and OptionsOpened() then
  addon.opt.initializing = false
  addon:PopulateItemsList_new()
  tmp = nil
 else
 if addon.waiting_ids[arg] ~= nil then
  addon.waiting_ids[arg] = {["notreceived"] = true}
  if OptionsOpened() and tmp == nil then
   tmp = addon:ScheduleTimer("Waiting_ID_Timer", 2, "##initrefresh##")
   addon.opt.initializing = true
--   addon:PopulateItemsList_new()
  end
 end
 end
end

local PLFrame = CreateFrame("FRAME")
PLFrame:RegisterEvent("GET_ITEM_INFO_RECEIVED")
PLFrame:RegisterEvent("CHAT_MSG_LOOT")
PLFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
PLFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
local function eventHandler(self, event, ...)
 if event == "GET_ITEM_INFO_RECEIVED" then
  PLFrame:GET_ITEM_INFO_RECEIVED()
 elseif event == "CHAT_MSG_LOOT" then
  PLFrame:LootCheck(...)
 elseif event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED" then
  PLFrame:CombatCheck(self,event)
 end
end
PLFrame:SetScript("OnEvent", eventHandler)

function PLFrame:GET_ITEM_INFO_RECEIVED()
 table.foreach(addon.waiting_ids, 
 function(k,v)
  if OptionsOpened() then
   if not v["notreceived"] then
    local itemName, itemLink,_,_,_,_,_,_,_, itemTexture = GetItemInfo(k)
    if itemLink then
     if not addon.opt.initializing then
      addon:PopulateItemsList_new()
     elseif tmp == nil then
      tmp = addon:ScheduleTimer("Waiting_ID_Timer", 2, "##initrefresh##")
      addon.opt.initializing = true
     end
     addon:CancelTimer(v["timer"],true)
     addon.waiting_ids[k] = nil
    end
   end
  end
 end)
end

function PLFrame:LootCheck(arg1,arg11)
 local LOOT_SELF_REGEX = gsub(LOOT_ITEM_SELF, "%%s", "(.+)")
 local LOOT_REGEX = gsub(LOOT_ITEM, "%%s", "(.+)")

 local function CharLoots(char,id,link)
  if addon:TableMatch(PLWish_List[char],id,true) then
   if not addon:IsLooted(PLWish_List[char][addon:GetItemPos(char,id)]) then
    if not addon:IsSimpleMode() then
     DEFAULT_CHAT_FRAME:AddMessage(AddColor("<<"..L["<addon name>"]..">>",LIGHT_BLUE).." - "..char.." loots "..link..", looted flag set.")
    end
    addon:SetLooted(char,id,true,true)
   end
  end
 end

 local _, _, p, itemlink = string.find(arg1, LOOT_REGEX)
 if not p then _, _, itemlink = string.find(arg1, LOOT_SELF_REGEX) end
 if not itemlink then return end
 local _, _, itemID = string.find(itemlink, "item:(%d+):")
 if itemID then
  if p then -- p did loot itemID
   CharLoots(p,tonumber(itemID),itemlink)
  else -- I did loot itemID
   CharLoots(UnitName("player"),tonumber(itemID),itemlink)
  end
 end
end

function PLFrame:CombatCheck(self,event)
 if event == "PLAYER_REGEN_ENABLED" then
  --
 elseif event == "PLAYER_REGEN_DISABLED" then
  if OptionsOpened() then
   addon:CloseMainOptionsFrame()
  end
 end
end

-- loot window - item tooltip
hooksecurefunc(GameTooltip, "SetLootItem", function(tooltip, slot)
if not addon:IsSimpleMode() then
 if (LootSlotHasItem(slot)) and GetLootSlotLink(slot) ~= nil then
  local iLink = strtrim(GetLootSlotLink(slot))
  local _, _, sLink = strfind(iLink, "^|%x+|H(.+)")
  local p, _, ItemID = strfind(sLink, "^item:(%-?%d+):?")
  local i = 0
  local items_group = {}
  local lines = {}
  if p then ItemID = tonumber(ItemID) else ItemID = nil end

  if ItemID ~= nil and ItemID > 0 then
   -- different loot priorities between raids v2.0.6
    local raid = addon:getitemsraid(ItemID)
   --

   if addon.lootlist[raid] and addon.lootlist[raid][ItemID] then
    table.insert(items_group,{i_id = ItemID, flag = ""})
    if pl_options["treatdiff"] and raid ~= "general" then
     for bossname,t_diff in pairs(addon.boss_drops_table[raid]) do
      for diff,t_items in pairs(t_diff) do
       if diff ~= "icon" then
       for index,id in pairs(t_items) do
        if id == ItemID then
         for k,v in pairs(t_diff) do
          if v[index] ~= id and k ~= "icon" then
           table.insert(items_group,{i_id = v[index], flag = "("..k..")"})
          end
         end
         break
        end
       end
      end
     end
    end -- raid
    end --treatdiff option enabled

    local found = false
    for a,b in pairs(items_group) do
    if addon.lootlist[raid] and addon.lootlist[raid][b.i_id] then
    table.foreach(addon.lootlist[raid][b.i_id],
    function(k,v)
     if v.prio ~= PRIO_LOOTED then
      found = true
      local t = nil
      table.foreach(lines,function(index,line) if line.prio == v.prio then t = index end end)
      if t == nil then t = table.getn(lines) end
      if lines[t] and lines[t].prio == v.prio then
       lines[t].s = lines[t].s.." |col|"..v.name..AddColor(b.flag,GREY)
      else
       table.insert(lines, {prio = v.prio, s = "|col| - "..v.name..AddColor(b.flag,GREY)})
      end
     end
    end)
    end
    end --for do
     if not found then
      --if all characters did loot this item and nobody else needs it
      table.insert(lines,1, {prio = 0, s = AddColor(L["noneeders"],LIGHT_RED)})
     else
      table.sort(lines,function(a,b) return a.prio < b.prio end)
      table.insert(lines,1,{prio = 0, s = AddColor(L["itemgoesto"],LIGHT_BLUE)})
      table.insert(lines,3,{prio = 0, s = AddColor(L["nextneeds"],LIGHT_BLUE) })
     end
      tooltip:AddDoubleLine(L["<addon name>"]..":", GetItemInfo(ItemID))
      table.foreach(lines,
      function(k,v)
       i = i + 1
       local str_prio = AddColor(" (#"..v.prio..")",WHITE)
       if i == 2 then v.s = string.gsub(v.s, "|col|", YELLOW)..str_prio
--   elseif i == 4 then v.s = string.gsub(v.s, "|col|", LIGHT_RED)..str_prio
   elseif i ~= 1 and i ~= 3 then
        v.s = string.gsub(v.s, "|col|", LIGHT_GREEN)..str_prio
       end
       tooltip:AddLine(v.s)
      end)
     end
  else
   tooltip:AddLine(L["<addon name>"].." - "..L["IDnotfound"],1,1,1)
  end
  tooltip:Show()
 end
end--simple mode check
end)

-- hyperlink static frame - item tooltip
hooksecurefunc(ItemRefTooltip, "SetHyperlink", function (tooltip, item)
if ItemRefTooltip.PL_additem_btn then ItemRefTooltip.PL_additem_btn:Hide() end

local itemname, iLink = GetItemInfo(item)
if (iLink)and(pl_options["ttlinkbtn"])and(ItemRefTooltip.WL_TOOLTIP == nil) then -- it's an item
 local _, _, sLink = strfind(iLink, "^|%x+|H(.+)")
 local p, _, ItemID = strfind(sLink, "^item:(%-?%d+):?")
 if p then ItemID = tonumber(ItemID) else ItemID = nil end
 local player = UnitName("player")
 if ItemID ~= nil and ItemID > 0 then
  if (PLWish_List[player] and addon:TableMatch(PLWish_List[player],ItemID,true)) then
   tooltip:AddDoubleLine(L["<addon name>"]..":",L["ialreadyexists"])
   tooltip:AddLine("ID: "..ItemID)
   tooltip:Show()
  else
   if not ItemRefTooltip.PL_additem_btn then
    ItemRefTooltip.PL_additem_btn = CreateFrame("Button", "PLTooltipButton", tooltip, "UIPanelButtonTemplate")
   end
   tooltip:AddLine(L["<addon name>"]..":")
   tooltip:AddDoubleLine("                    ","                    ")
   tooltip:AddLine("ID: "..ItemID)
   ItemRefTooltip.PL_additem_btn:SetPoint("BOTTOMRIGHT", tooltip, "BOTTOMRIGHT", -20, 16);
   ItemRefTooltip.PL_additem_btn:SetText(L["Ineedthis"])
   ItemRefTooltip.PL_additem_btn:SetWidth(100)
   ItemRefTooltip.PL_additem_btn:SetScript("OnClick", function()
                                      if table.getn(addon.import_var.Wish_List) == 0 then
                                       tooltip:Hide()
                                       PriorityList:Init_OptionsFrame("main")
                                       PriorityList:AddItem(player,ItemID,true)
                                      end
                                     end)
   ItemRefTooltip.PL_additem_btn:Show()
   tooltip:Show()
  end
 end
 end
end)